#ifndef __CONFIGURATION_MANAGER_H__
#define __CONFIGURATION_MANAGER_H__

#include "data.h"
#include <glibmm.h>

class ConfigurationManager
{
private:
	class Entry
	{
	public:
		Entry() : id(0) {}

		guint id;
		Glib::ustring name;
		Glib::ustring value;
	};

	class EntryList : public std::list<Entry>
	{
	public:
		gboolean contains(const Glib::ustring& name);
		void add(const Glib::ustring& name, const Glib::ustring& value);
		void add(int id, const Glib::ustring& name, const Glib::ustring& value);
		Glib::ustring get(const Glib::ustring& name);
	};

	EntryList entries;
	
public:
	void load(Data::Schema& schema, Data::Connection& connection);
	void save(Data::Schema& schema, Data::Connection& connection);

	void set_value(const Glib::ustring& name, const Glib::ustring& value);
	void set_value(const Glib::ustring& name, int value);

	Glib::ustring get_value(const Glib::ustring& name);
	int get_int_value(const Glib::ustring& name);

	void set_default_value(const Glib::ustring& name, const Glib::ustring& value);
	void set_default_value(const Glib::ustring& name, int value);
};

#endif
